function [chain_values_out] = blake256_finalization(chain_values_in,v_data, salt)
%Ova funkcija radi blake finalizaciju na osnovu SHA-3 proposal
%BLAKEdokumenta  strana 11


chain_values_out(1) = bitxor(bitxor(chain_values_in(1), salt(1)), bitxor(v_data(1,1), v_data(3,1)));
chain_values_out(2) = bitxor(bitxor(chain_values_in(2), salt(2)), bitxor(v_data(1,2), v_data(3,2)));
chain_values_out(3) = bitxor(bitxor(chain_values_in(3), salt(3)), bitxor(v_data(1,3), v_data(3,3)));
chain_values_out(4) = bitxor(bitxor(chain_values_in(4), salt(4)), bitxor(v_data(1,4), v_data(3,4)));
chain_values_out(5) = bitxor(bitxor(chain_values_in(5), salt(1)), bitxor(v_data(2,1), v_data(4,1)));
chain_values_out(6) = bitxor(bitxor(chain_values_in(6), salt(2)), bitxor(v_data(2,2), v_data(4,2)));
chain_values_out(7) = bitxor(bitxor(chain_values_in(7), salt(3)), bitxor(v_data(2,3), v_data(4,3)));
chain_values_out(8) = bitxor(bitxor(chain_values_in(8), salt(4)), bitxor(v_data(2,4), v_data(4,4)));

end

