function [v_data_out] = blake256_rounds(v_data_in, message, permutation_matrix, constants, num_of_blake_call)

for round = 0:13,
    
    %For G0
    [v_data_in(1,1), v_data_in(2,1), v_data_in(3,1), v_data_in(4,1)] = g_fcn(v_data_in(1,1),v_data_in(2,1),v_data_in(3,1),v_data_in(4,1), round, 0, num_of_blake_call, message, permutation_matrix, constants);
    
    %For G1
    [v_data_in(1,2), v_data_in(2,2), v_data_in(3,2), v_data_in(4,2)] = g_fcn(v_data_in(1,2),v_data_in(2,2),v_data_in(3,2),v_data_in(4,2), round, 1, num_of_blake_call, message, permutation_matrix, constants);
    
    %For G2
    [v_data_in(1,3), v_data_in(2,3), v_data_in(3,3), v_data_in(4,3)] = g_fcn(v_data_in(1,3),v_data_in(2,3),v_data_in(3,3),v_data_in(4,3), round, 2, num_of_blake_call, message, permutation_matrix, constants);
    
    %For G3
    [v_data_in(1,4), v_data_in(2,4), v_data_in(3,4), v_data_in(4,4)] = g_fcn(v_data_in(1,4),v_data_in(2,4),v_data_in(3,4),v_data_in(4,4), round, 3, num_of_blake_call, message, permutation_matrix, constants);
    
    %For G4
    [v_data_in(1,1), v_data_in(2,2), v_data_in(3,3), v_data_in(4,4)] = g_fcn(v_data_in(1,1),v_data_in(2,2),v_data_in(3,3),v_data_in(4,4), round, 4, num_of_blake_call, message, permutation_matrix, constants);
    
    %For G5
    [v_data_in(1,2), v_data_in(2,3), v_data_in(3,4), v_data_in(4,1)] = g_fcn(v_data_in(1,2),v_data_in(2,3),v_data_in(3,4),v_data_in(4,1), round, 5, num_of_blake_call, message, permutation_matrix, constants);
    
    %For G6
    [v_data_in(1,3), v_data_in(2,4), v_data_in(3,1), v_data_in(4,2)] = g_fcn(v_data_in(1,3),v_data_in(2,4),v_data_in(3,1),v_data_in(4,2), round, 6, num_of_blake_call, message, permutation_matrix, constants);
    
    %For G7
    [v_data_in(1,4), v_data_in(2,1), v_data_in(3,2), v_data_in(4,3)] = g_fcn(v_data_in(1,4),v_data_in(2,1),v_data_in(3,2),v_data_in(4,3), round, 7, num_of_blake_call, message, permutation_matrix, constants);
    
end %endfor

v_data_out = v_data_in;

end %function